#include "crogue.h"

void Graph_DrawTile(UI_Tilefield *tf, int x, int y, UI_TF_TileInfo tile)
{
	void *light;
	void *dark;
	const uchar *lighttile;
	const uchar *darktile;
	
	if(w->options[OPTION_GRAYSCALE] == OPTION_GRAY_ON)
	{
		light = GrayGetPlane(LIGHT_PLANE);
		dark = GrayGetPlane(DARK_PLANE);
		switch(tile.lighting)
		{
			case LIGHTING_LIT:
				lighttile = darktile = tf->graphics + tile.tile*tf->tileheight;
				break;
			case LIGHTING_DARK:
				lighttile = tf->graphics + (tf->tileheight * blacktile);
				darktile = tf->graphics + tile.tile*tf->tileheight;
				break;
			case LIGHTING_UNEXPLORED:
				lighttile = tf->graphics + (tf->tileheight * whitetile);
				darktile = tf->graphics + (tf->tileheight * blacktile);
				break;
			default:
				return;
		}
		GraySprite8_BLIT(tf->pos.x + x * tf->tilewidth,
			tf->pos.y + y * tf->tileheight,
			tf->tileheight,
			lighttile,
			darktile,
			0xFF >> tf->tileheight,
			light,
			dark);
	} else {
		switch(tile.lighting)
		{
			case LIGHTING_LIT:
				if(tile.tile == 3) tile.tile = 4;
			case LIGHTING_DARK:
				darktile = tf->graphics + tile.tile * tf->tileheight;
				break;
			case LIGHTING_UNEXPLORED:
				darktile = tf->graphics + 17 * tf->tileheight;
				break;
			default:
				return;
		}
		GraySprite8_BLIT(tf->pos.x + x * tf->tilewidth,
			tf->pos.y + y * tf->tileheight,
			tf->tileheight,
			darktile,
			darktile,
			0xFF >> tf->tileheight,
			LCD_MEM,
			LCD_MEM);
	}
}

