#!/bin/sh

#grep F_EXPORT include/dll_interface.h |awk "-F(" '{print($1)}' |sed -e 's/*//g' |awk \
#  '{num_functions+=1; print("define(" $NF ", DLL_LINK(" num_functions-1 "))")}'\
#  >data/automatic.m4

DATADIR=data

#
# data/automatic.m4: Data file definitions of functions exported from the DLL
#
grep -h F_EXPORT dll/dll_interface.h |awk "-F(" '{print($2)}' \
  |awk "-F)" '{num_functions+=1; print("export " $1 " (PTR_DLLCALL, " num_functions-1 ");")}'\
  >${DATADIR}/automatic.m4

#
# auto/dll_export.h: Prototypes for functions exported from DLL for use by the
# data file and main program
#
echo "/* Generated file - do not edit */" >auto/dll_export.h
echo "typedef struct export_functions {" >>auto/dll_export.h
grep -h F_EXPORT dll/dll_interface.h \
  |grep -v "#define"         \
  |sed -e 's/F_EXPORT(/(*/'  \
  >>auto/dll_export.h
echo "void *terminator; } export_functions;" >>auto/dll_export.h

echo "/* Generated file - do not edit */" >auto/export.h
grep -h F_EXPORT dll/dll_interface.h  \
  |grep -v "#define"          \
  |awk "-F(" '{ print($2) }'  \
  |awk "-F)" '{ print( "#define " $1 " (w->dll_interface->" $1 ")" ) }' \
  >>auto/export.h


#
# auto/dll_export.c: Table of functions exported from DLL for use by data file
# and main program
#
echo "/* Generated file - do not edit */" >auto/dll_export.c
echo "#include \"crogue.h\"" >>auto/dll_export.c
echo "#include \"dll_interface.h\"" >>auto/dll_export.c
echo "const export_functions dll_exports = {" >>auto/dll_export.c
grep -h F_EXPORT dll/dll_interface.h |awk "-F(" '{print($2)}' \
  |awk "-F)" '{print($1 ",")}'\
  >>auto/dll_export.c
echo "NULL };" >>auto/dll_export.c

#
# auto/dll_import.h: Prototypes for functions exported by the main program for
# use in the DLL
#
echo "/* Generated file - do not edit */" >auto/dll_import.h
echo "typedef struct import_functions {" >>auto/dll_import.h
grep -h F_EXPORT include/*.h auto/proto.h \
  |grep -v "#define"         \
  |sed -e 's/F_EXPORT(/(*/'  \
  >>auto/dll_import.h
echo "void *terminator; } import_functions;" >>auto/dll_import.h

#
# auto/import.h: Definitions for functions exported by the main program for
# use in the DLL
#
echo "/* Generated file - do not edit */" >auto/import.h
grep -h F_EXPORT include/*.h auto/proto.h \
  |grep -v "#define"          \
  |awk "-F(" '{ print($2) }'  \
  |awk "-F)" '{ print( "#define " $1 " (dll_body_functions->" $1 ")" ) }' \
  >>auto/import.h
echo "extern const import_functions *dll_body_functions;" >>auto/import.h

#
# auto/dll_import.c: Function pointers for functions exported by the main
# program for use in the DLL
#
echo "/* Generated file - do not edit */" >auto/dll_import.c
echo "#include \"crogue.h\"" >>auto/dll_import.c
echo "const import_functions body_functions = {" >>auto/dll_import.c
grep -h F_EXPORT include/*.h auto/proto.h \
  |grep -v "#define"          \
  |awk "-F(" '{ print($2) }'  \
  |awk "-F)" '{ print($1 ",") }' \
  >>auto/dll_import.c
echo "NULL };" >>auto/dll_import.c


